## ros-foxy-pendulum-control 0.9.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(pendulum_control)

if(APPLE OR WIN32)
  message(STATUS "The pendulum_control demo is only supported on Linux. Package will not be built.")
  return()
endif()

find_package(ament_cmake REQUIRED)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(rclcpp REQUIRED)
find_package(pendulum_msgs REQUIRED)
find_package(rttest)
find_package(tlsf_cpp)

include_directories(include)

if(NOT rttest_FOUND)
  message(STATUS "rttest not found. pendulum_control package will not be built.")
  return()
endif()

add_executable(pendulum_demo
  src/pendulum_demo.cpp)
ament_target_dependencies(pendulum_demo
  "pendulum_msgs"
  "rclcpp"
  "rttest"
  "tlsf_cpp")

add_executable(pendulum_logger
  src/pendulum_logger.cpp)
ament_target_dependencies(pendulum_logger
  "pendulum_msgs"
  "rclcpp"
  "rttest")

add_executable(pendulum_teleop
  src/pendulum_teleop.cpp)
ament_target_dependencies(pendulum_teleop
  "pendulum_msgs"
  "rclcpp"
  "rttest")

install(TARGETS
  pendulum_demo
  pendulum_logger
  pendulum_teleop
  DESTINATION bin)

install(
  PROGRAMS "scripts/pendulum_launch.bash"
  DESTINATION bin
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)
  find_package(launch_testing_ament_cmake REQUIRED)
  find_package(rmw_implementation_cmake REQUIRED)

  set(RCLCPP_DEMO_PENDULUM_LOGGER_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/pendulum_logger")
  set(RCLCPP_DEMO_PENDULUM_DEMO_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/pendulum_demo")
  set(RCLCPP_DEMO_PENDULUM_DEMO_TELEOP_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/pendulum_demo_teleop")
  set(RCLCPP_DEMO_PENDULUM_TELEOP_EXPECTED_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/test/pendulum_teleop")

  get_available_rmw_implementations(rmw_implementations)
  foreach(rmw_implementation ${rmw_implementations})
    # FastRTPS doesn't (yet) support the use of custom allocators, so it will
    # fail this test, which requires that no actual allocation happens during
    # execution.
    set(SKIP_TEST "")
    if(
      ${rmw_implementation} STREQUAL "rmw_fastrtps_cpp" OR
      ${rmw_implementation} STREQUAL "rmw_fastrtps_dynamic_cpp"
    )
      set(SKIP_TEST "SKIP_TEST")
    endif()

    set(RCLCPP_DEMO_PENDULUM_LOGGER_EXECUTABLE "${CMAKE_CURRENT_BINARY_DIR}/pendulum_logger")
    set(RCLCPP_DEMO_PENDULUM_DEMO_EXECUTABLE "${CMAKE_CURRENT_BINARY_DIR}/pendulum_demo")
    set(RCLCPP_DEMO_PENDULUM_TELEOP_EXECUTABLE "${CMAKE_CURRENT_BINARY_DIR}/pendulum_teleop")

    configure_file(
      test/test_pendulum_demo.py.in
      test_pendulum__${rmw_implementation}.py
      @ONLY
    )

    configure_file(
      test/test_pendulum_teleop.py.in
      test_pendulum_teleop__${rmw_implementation}.py
      @ONLY
    )

    configure_file(
      test/execute_with_delay.py
      execute_with_delay.py
    )

    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/test_pendulum__${rmw_implementation}")
    add_launch_test(
      "${CMAKE_CURRENT_BINARY_DIR}/test_pendulum__${rmw_implementation}.py"
      TARGET test_pendulum__${rmw_implementation}
      TIMEOUT 20
      ENV
      RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
      RMW_IMPLEMENTATION=${rmw_implementation}
      # since the test generates a .csv file in the cwd
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/test_pendulum__${rmw_implementation}"
      ${SKIP_TEST}
    )
    if(TEST test_pendulum__${rmw_implementation})
      set_tests_properties(test_pendulum__${rmw_implementation}
        PROPERTIES DEPENDS "test_pendulum__${rmw_implementation} test_pendulum__${rmw_implementation}")
    endif()

    add_launch_test(
      "${CMAKE_CURRENT_BINARY_DIR}/test_pendulum_teleop__${rmw_implementation}.py"
      TARGET test_pendulum_teleop__${rmw_implementation}
      TIMEOUT 20
      ENV
      RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
      RMW_IMPLEMENTATION=${rmw_implementation}
      ${SKIP_TEST}
    )
    if(TEST test_pendulum_teleop__${rmw_implementation})
      set_tests_properties(test_pendulum_teleop__${rmw_implementation}
        PROPERTIES DEPENDS "test_pendulum_teleop__${rmw_implementation} test_pendulum_teleop__${rmw_implementation}")
    endif()
  endforeach()
endif()

ament_package()

=== debian/changelog ===
ros-foxy-pendulum-control (0.9.4-1focal) focal; urgency=high

  * Update maintainer list for Foxy (#471 <https://github.com/ros2/demos/issues/471>)
  * Contributors: Michael Jeronimo

 -- Mabel Zhang <mabel@openrobotics.org>  Mon, 25 Jul 2022 07:00:00 -0000

ros-foxy-pendulum-control (0.9.3-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 01 Jun 2020 07:00:00 -0000

ros-foxy-pendulum-control (0.9.2-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 26 May 2020 07:00:00 -0000

ros-foxy-pendulum-control (0.9.1-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 12 May 2020 07:00:00 -0000

ros-foxy-pendulum-control (0.9.0-1focal) focal; urgency=high

  * avoid new deprecations (#442 <https://github.com/ros2/demos/issues/442>)
  * fix CMake warning about using uninitialized variables (#439 <https://github.com/ros2/demos/issues/439>)
  * Fix pendulum_control tests to use stdout stream. (#430 <https://github.com/ros2/demos/issues/430>)
  * code style only: wrap after open parenthesis if not in one line (#429 <https://github.com/ros2/demos/issues/429>)
  * Contributors: Chris Lalancette, Dirk Thomas, William Woodall

 -- Michael Carroll <michael@openrobotics.org>  Thu, 30 Apr 2020 07:00:00 -0000

ros-foxy-pendulum-control (0.8.4-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 19 Nov 2019 08:00:00 -0000

ros-foxy-pendulum-control (0.8.3-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 11 Nov 2019 08:00:00 -0000

ros-foxy-pendulum-control (0.8.2-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Fri, 08 Nov 2019 08:00:00 -0000

ros-foxy-pendulum-control (0.8.1-1focal) focal; urgency=high

  * Replace ready_fn with ReadyToTest action (#404 <https://github.com/ros2/demos/issues/404>)
  * Contributors: Peter Baughman

 -- Michael Carroll <michael@openrobotics.org>  Wed, 23 Oct 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.8.0-1focal) focal; urgency=high

  * Fixes to pendulum_control demo (#385)
    
    Add asserts to ensure that the latency is never negative
    
    Switch last_sample to int64_t to match new rttest interface
    
    Allow any number of spaces
    
    Make sure to expect the extra newline for the pendulum_demo
    
    Only publish statistics if they are available.
    
    Remove some unused functions from rtt_executor.hpp
  * Fix armhf build warnings (#372 <https://github.com/ros2/demos/issues/372>)
  * Contributors: Chris Lalancette, Prajakta Gokhale

 -- Michael Carroll <michael@openrobotics.org>  Thu, 26 Sep 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.7.6-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Thu, 30 May 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.7.5-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Wed, 29 May 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.7.4-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 20 May 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.7.3-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Fri, 10 May 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.7.2-1focal) focal; urgency=high

  * changes to avoid deprecated API's (#332 <https://github.com/ros2/demos/issues/332>)
  * Corrected publish calls with shared_ptr signature (#327 <https://github.com/ros2/demos/issues/327>)
  * Migrate launch tests to new launch_testing features & API (#318 <https://github.com/ros2/demos/issues/318>)
  * Contributors: Michel Hidalgo, William Woodall, ivanpauno

 -- Michael Carroll <michael@openrobotics.org>  Wed, 08 May 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.7.1-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Fri, 26 Apr 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.7.0-1focal) focal; urgency=high

  * Removed unused lambda capture. (#315 <https://github.com/ros2/demos/issues/315>)
  * Added launch along with launch_testing as test dependencies. (#313 <https://github.com/ros2/demos/issues/313>)
  * Dropped legacy launch API usage. (#311 <https://github.com/ros2/demos/issues/311>)
  * Contributors: Emerson Knapp, Michel Hidalgo

 -- Michael Carroll <michael@openrobotics.org>  Sun, 14 Apr 2019 07:00:00 -0000

ros-foxy-pendulum-control (0.6.2-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 15 Jan 2019 08:00:00 -0000

ros-foxy-pendulum-control (0.6.1-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-foxy-pendulum-control (0.6.0-1focal) focal; urgency=high

  * Updated package maintainer. (#286 <https://github.com/ros2/demos/issues/286>)
  * Updated to match rmw_fastrtps_dynamic_cpp (#271 <https://github.com/ros2/demos/issues/271>)
  * Fixed spacing to comply with uncrusity 0.67 (#267 <https://github.com/ros2/demos/issues/267>)
  * Fixed no return code for main() in several files (#266 <https://github.com/ros2/demos/issues/266>)
  * Contributors: Dirk Thomas, Michael Carroll, Mikael Arguedas, testkit

 -- Michael Carroll <michael@openrobotics.org>  Fri, 07 Dec 2018 08:00:00 -0000

ros-foxy-pendulum-control (0.5.1-1focal) focal; urgency=high

  * make Mikael Arguedas the maintainer (#263 <https://github.com/ros2/demos/issues/263>)
  * Contributors: Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Thu, 28 Jun 2018 07:00:00 -0000

ros-foxy-pendulum-control (0.5.0-1focal) focal; urgency=high

  * Updated launch files to account for the "old launch" getting renamespaced as ``launch`` -> ``launch.legacy``. (#239 <https://github.com/ros2/demos/issues/239>)
  * Fixed the pendulum's inertia in the physic model. (#220 <https://github.com/ros2/demos/issues/220>)
  * Contributors: Dirk Thomas, Thomas de Candia, William Woodall, dhood



=== debian/control ===
Source: ros-foxy-pendulum-control
Section: misc
Priority: optional
Maintainer: Mabel Zhang <mabel@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-pytest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-launch, ros-foxy-launch-testing, ros-foxy-launch-testing-ament-cmake, ros-foxy-launch-testing-ros, ros-foxy-pendulum-msgs, ros-foxy-rclcpp, ros-foxy-rmw-implementation-cmake, ros-foxy-ros2run, ros-foxy-rttest, ros-foxy-tlsf-cpp, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-pendulum-control
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-pendulum-msgs, ros-foxy-rclcpp, ros-foxy-rttest, ros-foxy-tlsf-cpp, ros-foxy-ros-workspace
Description: Demonstrates ROS 2's realtime capabilities with a simulated inverted pendulum.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-pendulum-control//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
